/*
 $Header: /home/fujiwara/.cvsroot/tcpd/parse_syslog.c,v 1.8 2000/02/20 19:49:01 fujiwara Exp $

 Parse syslog option
 written by Kazunori Fujiwara <fujiwara@rcac.tdi.co.jp>
*/

#include <unistd.h>
#define SYSLOG_NAMES
#include <syslog.h>
#include <ctype.h>

/* 
   convert string like "local0.notice" to LOG_MAKEPRI value
*/

int tcpd_parse_syslog(char *str, char **left)
{
	CODE *c;
	int l;
	int m;

	if (left != NULL)
		*left = str;
	for (c = facilitynames; c->c_name != NULL; c++) {
		l = strlen(c->c_name);
		if (!strncasecmp(str, c->c_name, l) && str[l] == '.')
			break;
	}
	if (c->c_name == NULL)
		return -1;
	m = c->c_val;
	str += l + 1;
	for (c = prioritynames; c->c_name != NULL; c++) {
		l = strlen(c->c_name);
		if (!strncasecmp(str, c->c_name, l)
			&& !isalnum(str[l]))
			break;
	}
	if (c->c_name == NULL)
		return -1;

	if (left != NULL)
		*left = str+l;
	return m | c->c_val;
}

#ifdef DEBUG_parse_syslog
#include <stdio.h>

int main(int argc, char *argv[])
{
	int l;

	l = tcpd_parse_syslog(argv[1], NULL);

	printf("%02x %d.%d\n", l, l >> 3, l & 7);
}
#endif
