/*
 $Header: /home/fujiwara/.cvsroot/tcpd/refuse.c,v 1.8 1997/12/16 18:02:09 fujiwara Exp $

 refuse()
*/

#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <syslog.h>

#include <tcpd.h>

void refuse(struct request_info *req)
{
	char s1[TCPD_STRINGLEN];
	char s2[TCPD_STRINGLEN];

	tcpd_satostr(s1, sizeof s1, &req->src);
	tcpd_satostr(s2, sizeof s2, &req->dst);

	syslog(deny_severity, "refused connect from %s%s%s[%s] to %s@%s[%s] at line %d%s%s",
		req->user, req->user[0] == '\0' ? "": "@",
		req->src_name, s1,
		req->service,
		req->dst_name, s2,
		req->lineno,
	    req->error < 0 ? " error": "",
		req->wrongdns ? " src/dst DNS wrong(fake?)" : "");
	clean_exit(req);
}

